Subject: Re: [PATCH] Make virtio_net support carrier detection

From: Rusty Russell <[email-masked]>
Date: Fri, 13 Mar 2009 08:09:49 +1030

On Thursday 12 March 2009 23:22:35 David Miller wrote:
> Not adding a link state handler to virtio_net for pompous reasons like
> some theoretical "clean design" claim is idiotic, and in the end bad
> for users who are using existing versions of NetworkManager.

We really don't know if there's a carrier: virtio_net doesn't support it
(yet).

Dan said we can't return "don't know", but he's wrong: you get
-EOPNOTSUPP from ETHTOOL_GLINK.  That surely gives userspace the best
possible information.

> If the link is always on, you should make that explicit by providing
> a link state handler, and making sure it always returns true.

"If".  We've discussed adding a virtio_net feature to indicate link status,
which implies that it's *not* always on.

Rusty.